package de.intevation.gnv.raster;

import org.apache.log4j.Logger;

/**
 * @author Sascha L. Teichmann (sascha.teichmann@intevation.de)
 */
public class ExternalIndexConverter
implements   JTSMultiPolygonProducer.ValueConverter
{
    private static Logger log = Logger.getLogger(
        ExternalIndexConverter.class);

    protected Palette palette;

    public ExternalIndexConverter() {
    }

    public ExternalIndexConverter(Palette palette) {
        this.palette = palette;
    }

    public Integer convert(Integer value) {
        if (value == null) {
            return value;
        }

        int v = value.intValue();

        if (v == -1) {
            return value;
        }

        Palette.Entry entry = palette.getEntryByIndex(v);

        if (entry == null) {
            log.warn("cannot find palette entry for index: " + v);
            return value;
        }

        return Integer.valueOf(entry.getExternalIndex());
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
